Subject: Re: Netlink API for bonding ?

From: Stephen Hemminger <[email-masked]>
Date: Thu, 17 Sep 2009 14:51:20 -0700

On Thu, 17 Sep 2009 23:44:30 +0200
Nicolas de Pesloüan <[email-masked]> wrote:

> Stephen Hemminger wrote:
> > On Mon, 31 Aug 2009 22:34:50 +0200
> > Nicolas de Pesloüan <[email-masked]> wrote:
> > 
> >> Stephen,
> >>
> >> Can you please describe the netlink API you plan to implement for bonding ?
> >>
> >> Both Jiri Pirko and I plan to add some advanced active slave selection rules, 
> >> for more-than-two-slaves bonding configuration.
> >>
> >> Jay suggested that such advanced features be implemented in user space, using 
> >> netlink to notify a daemon when slaves come up or fall down. I agree with Jay, 
> >> but don't want to design something without having first a view at your proposed 
> >> API for bonding.
> >>
> >> Do you plan to have some notification to user space, or only the ability to read 
> >> and set bonding configuration using netlink ?
> >>
> >> Thanks,
> >>
> >> 	Nicolas.
> > 
> > No paper spec, but was looking to add interface similar to vlan and macvlan.
> > Just use (and extend if needed) existing rtnl_link_ops.
> > 
> > 
> > Was not planning on adding a notification interface, thats good idea but
> > really not what I was looking at.
> 
> What kind of notification system would you suggest to notify userland that a 
> given bond device just lose the current active slave ?

First why should user land care?  Unless all slaves are gone maybe it
should just be transparent.

Use existing link ops mechanism (see vlan and macvlan). You may need
to add new operations, but these should be generic enough so that bonding and bridging
have same operations. 

     .newlink => create bond device
     .dellink => remove bond device
     .newport => add slave
     .delport => remove slave

Also, dellink should always work (even if slaves are present).

The terminology slave is not widely used outside of bonding, and so probably
shouldn't be buried in the API.